## scm 0.5.8-1

=== debian/changelog ===
scm (0.5.8-1) stable; urgency=low

  Fixed (large) icon.

 -- Tiboric <tiboric@aol.com>  Sun, 13 Feb 2011 01:59:08 +0000
