## scm 0.5.9-1

=== changelog ===
scm (0.5.9-1) stable; urgency=low

  Added delete function.

 -- Tiboric <Tiboric@aol.com>  Sun, 13 Feb 2011 23:00:10 +0000
