## scm 0.6.0-3

=== .py2deb_build_folder/scm/debian/changelog ===
scm (0.6.0-2) stable; urgency=low

  Added delete function, cmd experiment cmd funtion .

 -- Tiboric <Tiboric@aol.com>  Mon, 14 Feb 2011 19:12:46 +0000
