=== changelog ===
scm (0.6.0-3) stable; urgency=low

  Fixed bug with startup.

 -- Tiboric <Tiboric@aol.com>  Tue, 15 Feb 2011 21:35:50 +0000
