## scm 0.7.1-1

=== changelog ===
scm (0.7.1-1) stable; urgency=low

  added simple icon chooser

 -- Tiboric <Tiboric@aol.com>  Wed, 23 Feb 2011 17:56:47 +0000
