## scm 0.8.0-2

=== changelog ===
scm (0.8.0-2) stable; urgency=low

  Reworked UI, Added A Requested Feature

 -- Tiboric <Tiboric@aol.com>  Wed, 02 Mar 2011 11:08:04 +0000
