## scm 0.8.0-4

=== debian/changelog ===
scm (0.8.0-4) stable; urgency=low

  Reworked UI, Added A Requested Feature

 -- Tiboric <Tiboric@aol.com>  Wed, 02 Mar 2011 21:44:41 +0000
