## scm 0.8.1-1

=== debian/changelog ===
scm (0.8.1-1) stable; urgency=low

  Bug Fixes, And Icon Text now under Icon

 -- Tiboric <Tiboric@aol.com>  Fri, 11 Mar 2011 23:12:45 +0000
