=== debian/control ===
Source: scm
Section: user/desktop
Priority: extra
Maintainer: Tiboric <Tiboric@aol.com>
Build-Depends: debhelper (>= 5)
Standards-Version: 3.7.2

Package: scm
Architecture: all
Depends: python2.5, python-osso, python-dbus, python2.5-gtk2, rootsh
Description: A GUI for making Shortcuts for your Desktop
XSBC-Bugtracker: XSBC-Bugtracker: http://bugs.maemo.org
