## scm 0.8.1-2

=== debian/changelog ===
scm (0.8.1-2) stable; urgency=low

  Bug Fixes, And Icon Text now under Icon, Fixed Startup problems?

 -- Tiboric <Tiboric@aol.com>  Sun, 13 Mar 2011 16:36:12 +0000
