## scm 0.8.1-3

=== debian/changelog ===
scm (0.8.1-3) stable; urgency=low

  Bug Fixes, And Icon Text now under Icon, Fixed Startup problems?

 -- Tiboric <Tiboric@aol.com>  Sun, 13 Mar 2011 22:53:39 +0000
