## scm 0.8.1-4

=== debian/changelog ===
scm (0.8.1-4) stable; urgency=low

  Bug Fixes, And Icon Text now under Icon, Fixed Startup problems?

 -- Tiboric <Tiboric@aol.com>  Mon, 14 Mar 2011 02:09:58 +0000
