## scm 0.8.1-5

=== debian/changelog ===
scm (0.8.1-5) stable; urgency=low

  Bug Fixes, And Icon Text now under Icon, Fixed Startup problems?

 -- Tiboric <Tiboric@aol.com>  Mon, 14 Mar 2011 10:56:12 +0000
