## scm 0.8.2-1

=== debian/changelog ===
scm (0.8.2-1) stable; urgency=low

  Added banner notifications

 -- Tiboric <Tiboric@aol.com>  Mon, 14 Mar 2011 18:55:32 +0000
