## scm 0.8.2-2

=== debian/changelog ===
scm (0.8.2-2) stable; urgency=low

  Small UI Change

 -- Tiboric <Tiboric@aol.com>  Fri, 18 Mar 2011 20:24:35 +0000
