## scm 0.8.2-3

=== debian/changelog ===
scm (0.8.2-3) stable; urgency=low

  Small UI Change

 -- Tiboric <Tiboric@aol.com>  Sat, 19 Mar 2011 16:04:14 +0000
