=== debian/control ===
--- 
+++ 
@@ -7,6 +7,6 @@
 
 Package: scm
 Architecture: all
-Depends: python2.5, python-osso, python-dbus, python2.5-gtk2, rootsh
+Depends: python2.5, python-osso, python-dbus, python2.5-qt4, python-imaging, rootsh
 Description: A GUI for making Shortcuts for your Desktop
 XSBC-Bugtracker: XSBC-Bugtracker: http://bugs.maemo.org
